// This simple program tests a StringList class.  The user gets to choose preset test 
// cases or type in their own list of strings.
// The program then calls methods of the StringList class, so that results can be seen.

// written by Scott McElfresh  

import java.io.*;

public class StringListTester 
{
    private static int numtestcases = 9;
	public static void main(String[] args) throws IOException
	{
       InputStreamReader input = new InputStreamReader(System.in);
       BufferedReader keyboard = new BufferedReader(input);
       
       
  int whichtest = -9;
  while (whichtest != 0)
  {
       System.out.println("---------------------------------------------------------");
       System.out.println("Which do you want to test?");
       System.out.println("1: moveLastToFront");
       System.out.println("2: moveFirstToEnd");
       System.out.println("3: deleteLast");
       System.out.println("4: deleteFirst");
       System.out.println("5: deleteAt");
       System.out.println("6: insertAt");
       System.out.println("7: delete");
       System.out.println("0: quit");
       System.out.print("----> ");
       String answer = keyboard.readLine();
       whichtest = Integer.parseInt(answer);         
       switch (whichtest)
       {
           case 1:  testLastToFront();
                    break;
           case 2:  testFirstToEnd();
                    break;
           case 3:  testDeleteLast();
                    break;
           case 4:  testDeleteFirst();
                    break;
           case 5:  testDeleteAt();
                    break;
           case 6:  testInsertAt();
                    break;
           case 7:  testDelete();
                    break;
      }    
      for (int countblanklines = 0; countblanklines < 5; countblanklines ++)
             System.out.println(); 
   }
}

//*****************************
public static void testLastToFront()
{
    for (int i = 1 ; i <= numtestcases; i++)
    {
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         
         
         testlist.moveLastToFront();
         answer.moveLastToFront();
         
         if (!answer.equals(testlist))
         {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
         }
         else 
            System.out.println("   PASSED");     
    }
}
//*****************************
public static void testFirstToEnd()
{
    for (int i = 1 ; i <= numtestcases; i++)
    {
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         
         
         testlist.moveFirstToEnd();
         answer.moveFirstToEnd();
         
         if (!answer.equals(testlist))
         {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
         }
         else 
            System.out.println("   PASSED");     
    }
}
//*****************************
public static void testDeleteLast()
{
    for (int i = 1 ; i <= numtestcases; i++)
    {
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         
         
         testlist.deleteLast();
         answer.deleteLast();
         
         if (!answer.equals(testlist))
         {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
         }
         else 
            System.out.println("   PASSED");     
    }
}
//*****************************
public static void testDeleteFirst()
{
    for (int i = 1 ; i <= numtestcases; i++)
    {
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         
         
         testlist.deleteFirst();
         answer.deleteFirst();
         
         if (!answer.equals(testlist))
         {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
         }
         else 
            System.out.println("   PASSED");     
    }
}
//*****************************
public static void testDeleteAt()
{     
    for (int i = 1 ; i <= numtestcases; i++)
    {
         boolean thistestokay = true;
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         int [] nums = {0,testlist.getHowMany() + 1,testlist.getHowMany(),testlist.getHowMany() - 1,
         			testlist.getHowMany()/2, 1, testlist.getHowMany()-2
         			};
         		
      for (int which = 0; which< nums.length; which++)
      { 
          testlist = getTestCase(i);
          answer = new WorkingStringList(testlist);
          
          testlist.deleteAt(nums[which]);
          answer.deleteAt(nums[which]);
         
          if (!answer.equals(testlist))
          {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println ("ATTEMPED TO DELETE AT POSITION: " + nums[which]);
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
            thistestokay = false;
          }

      }
      if (thistestokay)
            System.out.println("   PASSED");
    
    }
}
//*****************************
public static void testInsertAt()
{    
     String s = new String("howdy");
    for (int i = 1 ; i <= numtestcases; i++)
    {
         boolean thistestokay = true;
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         int [] nums = {testlist.getHowMany() + 1, 0,testlist.getHowMany(), testlist.getHowMany() - 1, 
         			testlist.getHowMany()/2, 1, testlist.getHowMany()-2
         			};
         		
      for (int which = 0; which< nums.length; which++)
      { 
          testlist = getTestCase(i);
          answer = new WorkingStringList(testlist);
          
          testlist.insertAt(s, nums[which]);
          answer.insertAt(s,nums[which]);
         
          if (!answer.equals(testlist))
          {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println ("ATTEMPED TO INSERT AT POSITION: " + nums[which]);
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
            thistestokay = false;
          }

      }
      if (thistestokay)
            System.out.println("   PASSED");
    
    }
}


  
  //*****************************
public static void testDelete()
{    
    String sum = new String("Summer");
    String fall = new String("autumn");
    for (int i = 1 ; i <= numtestcases; i++)
    {
         boolean thistestokay = true;
         System.out.println();
         System.out.print("******  Test Case " + i + " *********");
         StringList testlist = getTestCase(i);
         WorkingStringList answer = new WorkingStringList(testlist);
         int [] nums = {0,1,testlist.getHowMany() -1, testlist.getHowMany()/2};
         
         String[] todelete = new String[nums.length + 2];
         todelete[0] = sum;
         todelete[1] = fall;
         for (int j = 0; j <  nums.length ; j++)
             if ((nums[j]>= 0) && (nums[j] < testlist.getHowMany()))
                 todelete[j+2] = testlist.getStringAt(nums[j]);

      for (int which = 0; which< todelete.length; which++)
      { 
          testlist = getTestCase(i);
          answer = new WorkingStringList(testlist);
          
          testlist.delete(todelete[which]);
          answer.delete(todelete[which]);
         
          if (!answer.equals(testlist))
          {
            System.out.println("   FAILED");
            System.out.println("!!!! PROBLEM FOUND: !!!!!!!");
            StringList display = getTestCase(i);
            
            System.out.println("Here are the original " + display.getHowMany() + " strings: ");
            display.displayAll();
            System.out.println ("ATTEMPED TO DELETE: " + todelete[which]);
            System.out.println("---- Expected answer:");
            System.out.print(answer.getHowMany() + " strings: ");
            answer.displayAll();
            System.out.println("---- Your answer:");
            System.out.print(testlist.getHowMany() + " strings: ");
            testlist.displayAll();
            
            thistestokay = false;
          }

      }
      if (thistestokay)
            System.out.println("   PASSED");
    
    }
}




  //*********************
  public static StringList getTestCase(int whichcase)
  { 
      StringList userlist = null;
      if (whichcase == 1)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("Scott");
          userlist.insert("Sarah");
          userlist.insert("Katie");
          userlist.insert("McElfresh");
       }
       if (whichcase == 2)
       {
          userlist = new StringList(6); // a list object tracking no items yet
          userlist.insert("a");
          userlist.insert("b");
          userlist.insert("c");
          userlist.insert("d");
          userlist.insert("e");
          userlist.insert("f");
       }       
       if (whichcase == 3)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("mom");
          userlist.insert("dad");
          userlist.insert("apple");
          userlist.insert("pie");
          userlist.insert("MOM");
          userlist.insert("DAD");
          userlist.insert("APPLE");
          userlist.insert("PIE");
          userlist.insert("Mom");
          userlist.insert("Dad");
          userlist.insert("Apple");
          userlist.insert("Pie");
       }
       if (whichcase == 4)
       {
          userlist = new StringList(4); // a list object tracking no items yet, but CAN track 4
          userlist.insert("mom");
          userlist.insert("dad");
          userlist.insert("apple");
          userlist.insert("pie");
       }
       if (whichcase == 5)
       {
          userlist = new StringList(1); // a list object tracking no items yet, but CAN track 4
          userlist.insert("Spring");
       }
       if (whichcase == 6)
       {
          userlist = new StringList(); // a list object tracking no items yet, but CAN track 4
          userlist.insert("April");
       }
       if (whichcase == 7)
       {
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert("a");
          userlist.insert("b");
          userlist.insert("c");
          userlist.insert("d");
          userlist.insert("e");
          userlist.insert("f");
          userlist.insert("g");
          userlist.insert("h");
          userlist.insert("i");
          userlist.insert("j");
          userlist.insert("k");
          userlist.insert("l");
       }  
       if (whichcase == 8)
       {  
          String mother = new String("mom");
          String father = new String("dad");
          String brother = new String("bro");
          String sister = new String("sis");
          userlist = new StringList(); // a list object tracking no items yet
          userlist.insert(mother);
          userlist.insert(father);
          userlist.insert(brother);
          userlist.insert(sister);
       }
       if (whichcase == 9)
       {
          userlist = new StringList();   // a list object tracking no items yet
       }
      
      return userlist; 
  }
 

}
